import { Component, OnInit, Output, EventEmitter, Input, ContentChild, ElementRef, OnChanges, DoCheck, SimpleChanges, AfterContentInit, AfterContentChecked, AfterViewInit, AfterViewChecked } from '@angular/core';
import { User } from '../models/user.model';
import { UsersService } from '../services/users.service';
import { NgModel } from '@angular/forms';

@Component({
  selector: 'app-user-form',
  templateUrl: './user-form.component.html',
  styleUrls: ['./user-form.component.sass'],
})
export class UserFormComponent implements OnChanges, OnInit, DoCheck, AfterContentInit, AfterContentChecked, AfterViewInit, AfterViewChecked {


  @Output() onUserAdded: EventEmitter<User> = new EventEmitter<User>(); 
  @Output() nameChange:EventEmitter<string> = new EventEmitter<string>();

  @Input() name: string;

  age:number = 45;

  user: User;

  isWarning: boolean = true;

  title: string = "Форма добавления пользователя";

  @ContentChild('fromParent')
  fromParent: ElementRef;


  ngOnChanges(changes: SimpleChanges) {
    console.log('ngOnChanges');
    console.log(changes);

  }

  ngOnInit() {
    console.log('ngOnInit');
  }

  ngDoCheck() {
    console.log('ngDoCheck');
  }

  ngAfterContentInit() {
    console.log('ngAfterContentInit');
  }

  ngAfterContentChecked() {
    console.log('ngAfterContentChecked');
  }

  ngAfterViewInit() {
    console.log('ngAfterViewInit');
  }

  ngAfterViewChecked() {
    console.log('ngAfterViewChecked');
  }





  constructor() { 
    this.user =  new User('John',15);
  }


  save(event, name: NgModel, age: NgModel) {
    
console.log(name);

    let userTmp: User = new User(name.value, age.value);
    this.onUserAdded.emit(userTmp);

    this.fromParent.nativeElement.textContent = "Hello Parent";
    
  }

  onChange(event) {
    this.name = event.target.value;
    //console.log(event.target.value);
  }

  onNameUserChange($event : string) {
      this.name = $event;
      this.nameChange.emit($event);
  }

  onUserNameChange($event) : void {
    if(this.user.name.length < 3) {
      this.user.name = "Имя пользователя должно быть больше 3х символов";
    }
    else {
      this.user.name = $event;
    }
  }

}
